// SPDX-License-Identifier: Zlib
/* ------------------------------------------------------------------------- */
/*!
 *  \file       mgl_bit.h
 *  \brief      MGL ビットフラグ定義
 *  \date       Since: January 8, 2021. 10:07:57 JST.
 *  \author     Acerola
 */
/* ------------------------------------------------------------------------- */

#ifndef INCGUARD_MGL_BIT_H_1610068077
#define INCGUARD_MGL_BIT_H_1610068077

#include <cstdint>

namespace MGL
{
/* ------------------------------------------------------------------------- */
/*!
 *  \brief      ビットフラグを生成
 *  \tparam     T   生成する型
 *  \param[in]  bit ビット番号
 *  \return     引数のビット番号をオンにしたT型の値
 */
/* ------------------------------------------------------------------------- */
template <typename T>
constexpr T MakeBit(uint8_t bit) noexcept
{
    return static_cast<T>(1 << bit);
}
}   // namespace MGL
#endif	// INCGUARD_MGL_BIT_H_1610068077

// vim: et ts=4 sw=4 sts=4
