// SPDX-License-Identifier: Zlib
/* ------------------------------------------------------------------------- */
/*!
 *  \file       mgl_chrono_module_default.cc
 *  \brief      MGL デフォルトの日付と時間のモジュール
 *  \date       Since: February 24, 2021. 4:52:16 JST.
 *  \author     Acerola
 */
/* ------------------------------------------------------------------------- */

#include <mgl/system/chrono/mgl_chrono_module_default.h>

#include <ctime>
#include <mgl/system/mgl_system_locale.h>

namespace MGL::System
{
/* ------------------------------------------------------------------------- */
/*!
 *  \brief      コンストラクタ
 */
/* ------------------------------------------------------------------------- */
DefaultChronoModule::DefaultChronoModule() noexcept
{
}


/* ------------------------------------------------------------------------- */
/*!
 *  \brief      現在の協定世界時間を取得
 *  \return     現在の協定世界時間
 */
/* ------------------------------------------------------------------------- */
POSIXTime DefaultChronoModule::GetUTCTime() const noexcept
{
    return time(nullptr);
}


/* ------------------------------------------------------------------------- */
/*!
 *  \brief      現在のローカル時間を取得
 *  \return     現在のローカル時間
 */
/* ------------------------------------------------------------------------- */
POSIXTime DefaultChronoModule::GetLocalTime() const noexcept
{
    return time(nullptr) + Locale().GetTimeDifferent();
}
}   // namespace MGL::System

// vim: et ts=4 sw=4 sts=4
